\subsection{PTS control and status registers}
\label{app:pts-regs-csr}

\subsubsection{Memory map summary}
\rowcolors{2}{gray!25}{white}
\resizebox{\textwidth}{!}{
\begin{tabular}{|l|l|l|l|l|}
\rowcolor{gray}
\color{white} SW Offset & \color{white} Type & \color{white} Name &
\color{white} HW prefix & \color{white} C prefix\\
0x0& REG & BIDR & pts\_bidr & BIDR\\
0x4& REG & CSR & pts\_csr & CSR\\
0x8& REG & LSR & pts\_lsr & LSR\\
\hline
\end{tabular}
}

\subsubsection{Register description}
\paragraph*{BIDR}\vspace{12pt}

\rowcolors{1}{white}{white}
\begin{tabular}{l l }
{\bf HW prefix:}  & pts\_bidr\\
{\bf HW address:}  & 0x0\\
{\bf SW prefix:}  & BIDR\\
{\bf SW offset:}  & 0x0\\
\end{tabular}

\vspace{12pt}
Board ID Register

\vspace{12pt}
\noindent
\resizebox{\textwidth}{!}{
\begin{tabular}{>{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} }
31 & 30 & 29 & 28 & 27 & 26 & 25 & 24\\
\hline
\multicolumn{8}{|c|}{\cellcolor{gray!25}BIDR[31:24]}\\
\hline
23 & 22 & 21 & 20 & 19 & 18 & 17 & 16\\
\hline
\multicolumn{8}{|c|}{\cellcolor{gray!25}BIDR[23:16]}\\
\hline
15 & 14 & 13 & 12 & 11 & 10 & 9 & 8\\
\hline
\multicolumn{8}{|c|}{\cellcolor{gray!25}BIDR[15:8]}\\
\hline
7 & 6 & 5 & 4 & 3 & 2 & 1 & 0\\
\hline
\multicolumn{8}{|c|}{\cellcolor{gray!25}BIDR[7:0]}\\
\hline
\end{tabular}
}

\begin{itemize}
\item \begin{small}
{\bf 
BIDR
} [\emph{read-only}]: ID register bits
\end{small}
\end{itemize}
\paragraph*{CSR}\vspace{12pt}

\rowcolors{1}{white}{white}
\begin{tabular}{l l }
{\bf HW prefix:}  & pts\_csr\\
{\bf HW address:}  & 0x1\\
{\bf SW prefix:}  & CSR\\
{\bf SW offset:}  & 0x4\\
\end{tabular}

\vspace{12pt}
Control and Status Register

\vspace{12pt}
\noindent
\resizebox{\textwidth}{!}{
\begin{tabular}{>{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} }
31 & 30 & 29 & 28 & 27 & 26 & 25 & 24\\
\hline
\multicolumn{1}{|c|}{\cellcolor{gray!25}I2C\_WDTO} & \multicolumn{1}{|c|}{\cellcolor{gray!25}I2C\_ERR} & \multicolumn{6}{|c|}{\cellcolor{gray!25}RTM[5:0]}\\
\hline
23 & 22 & 21 & 20 & 19 & 18 & 17 & 16\\
\hline
\multicolumn{8}{|c|}{\cellcolor{gray!25}SWITCH[7:0]}\\
\hline
15 & 14 & 13 & 12 & 11 & 10 & 9 & 8\\
\hline
\multicolumn{1}{|c|}{\cellcolor{gray!25}RST} & \multicolumn{1}{|c|}{\cellcolor{gray!25}RST\_UNLOCK} & \multicolumn{6}{|c|}{\cellcolor{gray!25}HWVERS[5:0]}\\
\hline
7 & 6 & 5 & 4 & 3 & 2 & 1 & 0\\
\hline
\multicolumn{1}{|c}{-} & - & - & \multicolumn{1}{|c|}{\cellcolor{gray!25}REARPT} & \multicolumn{1}{|c|}{\cellcolor{gray!25}TTLPT} & \multicolumn{1}{|c|}{\cellcolor{gray!25}RLEDT} & \multicolumn{1}{|c|}{\cellcolor{gray!25}STLEDT} & \multicolumn{1}{|c|}{\cellcolor{gray!25}CHLEDT}\\
\hline
\end{tabular}
}

\begin{itemize}
\item \begin{small}
{\bf 
CHLEDT
} [\emph{read/write}]: Channel pulse LED enable
\\
1 -- Enable channel LED sequencing \\                     0 -- No effect
\end{small}
\item \begin{small}
{\bf 
STLEDT
} [\emph{read/write}]: Status LED enable
\\
1 -- Enable front panel bicolor LED sequencing \\                     0 -- No effect
\end{small}
\item \begin{small}
{\bf 
RLEDT
} [\emph{read/write}]: Rear pulse LED line
\\
1 -- Set LED lines high \\                     0 -- No effect
\end{small}
\item \begin{small}
{\bf 
TTLPT
} [\emph{read/write}]: TTL test enable
\\
1 -- Enable pulse generation from CH1 \\                     0 -- No effect
\end{small}
\item \begin{small}
{\bf 
REARPT
} [\emph{read/write}]: Rear pulse enable
\\
1 -- Enable rear panel pulse generation \\                     0 -- No effect
\end{small}
\item \begin{small}
{\bf 
HWVERS
} [\emph{read-only}]: PCB version number
\\
6 bits representing HW/PCB version number \\                     4 MSB represent HW version number \\                     2 LSB represent number of execution \\                      Eg: value 010010 represents PCB version 4.2
\end{small}
\item \begin{small}
{\bf 
RST\_UNLOCK
} [\emph{read/write}]: Reset unlock bit
\\
1 -- Reset bit unlocked \\                     0 -- Reset bit locked
\end{small}
\item \begin{small}
{\bf 
RST
} [\emph{read/write}]: Reset bit -- active only if RST\_UNLOCK is 1
\\
1 -- initiate logic reset \\                     0 -- no reset
\end{small}
\item \begin{small}
{\bf 
SWITCH
} [\emph{read-only}]: switches
\\
1 - switch is ON \\                     0 - switch is OFF
\end{small}
\item \begin{small}
{\bf 
RTM
} [\emph{read-only}]: RTM detection lines
\\
1 - line active \\                     0 - line inactive
\end{small}
\item \begin{small}
{\bf 
I2C\_ERR
} [\emph{read/write}]: I2C communication error
\\
1 -- attempted to address non-existing address \\                     0 -- idle \\                     This bit can be cleared by writing a '1' to it
\end{small}
\item \begin{small}
{\bf 
I2C\_WDTO
} [\emph{read/write}]: I2C communication watchdog timeout error
\\
1 -- timeout occured \\                     0 -- no timeout \\                     This bit can be cleared by writing a '1' to it
\end{small}
\end{itemize}
\paragraph*{LSR}\vspace{12pt}

\rowcolors{1}{white}{white}
\begin{tabular}{l l }
{\bf HW prefix:}  & pts\_lsr\\
{\bf HW address:}  & 0x2\\
{\bf SW prefix:}  & LSR\\
{\bf SW offset:}  & 0x8\\
\end{tabular}

\vspace{12pt}
Line Status Register

\vspace{12pt}
\noindent
\resizebox{\textwidth}{!}{
\begin{tabular}{>{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} >{\centering\arraybackslash}p{1.5cm} }
31 & 30 & 29 & 28 & 27 & 26 & 25 & 24\\
\hline
\multicolumn{1}{|c}{-} & - & - & - & - & - & - & \multicolumn{1}{c|}{-}\\
\hline
23 & 22 & 21 & 20 & 19 & 18 & 17 & 16\\
\hline
\multicolumn{1}{|c}{-} & - & - & - & - & - & - & \multicolumn{1}{c|}{-}\\
\hline
15 & 14 & 13 & 12 & 11 & 10 & 9 & 8\\
\hline
\multicolumn{6}{|c|}{\cellcolor{gray!25}REAR[5:0]} & \multicolumn{2}{|c|}{\cellcolor{gray!25}FRONTINV[3:2]}\\
\hline
7 & 6 & 5 & 4 & 3 & 2 & 1 & 0\\
\hline
\multicolumn{2}{|c|}{\cellcolor{gray!25}FRONTINV[1:0]} & \multicolumn{6}{|c|}{\cellcolor{gray!25}FRONT[5:0]}\\
\hline
\end{tabular}
}

\begin{itemize}
\item \begin{small}
{\bf 
FRONT
} [\emph{read-only}]: Front panel channel input state
\\
Line state at board input\\      Bit 0 -- channel 1\\      Bit 1 -- channel 2\\      etc.
\end{small}
\item \begin{small}
{\bf 
FRONTINV
} [\emph{read-only}]: Front panel INV-TTL input state
\\
Line state at board input\\      Bit 0 -- channel 1\\      Bit 1 -- channel 2\\      etc.
\end{small}
\item \begin{small}
{\bf 
REAR
} [\emph{read-only}]: Rear panel input state
\\
Line state at board input\\      Bit 0 -- channel 1\\      Bit 1 -- channel 2\\      etc.
\end{small}
\end{itemize}



